diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 5c9d87f51..02bdc5fac 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -144,14 +144,14 @@ public class ScreenInventory extends ScreenContainerAbstract
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
-        super.render(xm, ym, partialTick);
-        xSize_lo = xm;
-        ySize_lo = ym;
+        super.render(mx, my, partialTick);
+        xSize_lo = mx;
+        ySize_lo = my;
 
         if(mc.gameSettings.armorProtectionOverlay.value && armorButton.enabled) {
-        	drawProtectionOverlay(xm, ym);
+        	drawProtectionOverlay(mx, my);
         }
         mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
         
@@ -160,7 +160,7 @@ public class ScreenInventory extends ScreenContainerAbstract
         glEnable(GL_TEXTURE_2D);
         
         if(armorButton.enabled) {
-            if(armorButton.isHovered(xm, ym)) {
+            if(armorButton.isHovered(mx, my)) {
             	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 185, 0, armorButton.width, armorButton.height);
             }else {
             	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 176, 0, armorButton.width, armorButton.height);
@@ -177,9 +177,9 @@ public class ScreenInventory extends ScreenContainerAbstract
 
         for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
         	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
-        	if(button.isHovered(xm, ym))
+        	if(button.isHovered(mx, my))
             {
-                tooltipElement.render(button.option.getDisplayStringName() + ": " + button.displayString, xm, ym, 8, -8);
+                tooltipElement.render(button.option.getDisplayStringName() + ": " + button.displayString, mx, my, 8, -8);
         	}
         }
         
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index bb352248b..80f2f2dca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -141,7 +141,7 @@ public class ScreenGuidebook
     }
 
     @Override
-    public void render(int xm, int ym, float renderPartialTicks) {
+    public void render(int mx, int my, float renderPartialTicks) {
         lastPage = guidebookPageManager.getLeftPage();
         scroll(Mouse.getDWheel());
 
@@ -154,12 +154,12 @@ public class ScreenGuidebook
         }
 
         renderBackground();
-        drawTabs(xm, ym);
-        drawCurrentPages(xm, ym, xOffset, renderPartialTicks);
+        drawTabs(mx, my);
+        drawCurrentPages(mx, my, xOffset, renderPartialTicks);
         drawHeaders(xOffset);
-        drawCurrentPageOverlays(xm, ym,xOffset,renderPartialTicks);
-        drawPageTurnIndicator(xm, ym, xOffset);
-        drawTooltip(xm, ym);
+        drawCurrentPageOverlays(mx, my,xOffset,renderPartialTicks);
+        drawPageTurnIndicator(mx, my, xOffset);
+        drawTooltip(mx, my);
     }
 
     private void scroll(int direction) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 534729149..5190d4e47 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -316,7 +316,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         return id;
     }
     @Override
-    public void render(int xm, int ym, float partialTick)
+    public void render(int mx, int my, float partialTick)
     {
         GL11.glViewport(0, 0, mc.gameWindow.getWidthPixels(), mc.gameWindow.getHeightPixels());
         GL11.glMatrixMode(GL11.GL_PROJECTION);
@@ -376,7 +376,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
         List<ButtonElement> _buttons = new ArrayList<>(buttons);
         for (ButtonElement button : _buttons) {
-            button.drawButton(mc, xm, ym);
+            button.drawButton(mc, mx, my);
         }
 
         scroll(Mouse.getDWheel());
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 65c9f64b6..e65fe006f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -203,19 +203,19 @@ public class ScreenOptions
     }
 
     @Override
-    public void render(int xm, int ym, float renderPartialTicks)
+    public void render(int mx, int my, float renderPartialTicks)
     {
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
-            xm = -1;
-            ym = -1;
-        } else if (doOptionsScroll && xm > pagesListWidth + SEPARATOR_WIDTH + PADDING && xm < width) {
+            mx = -1;
+            my = -1;
+        } else if (doOptionsScroll && mx > pagesListWidth + SEPARATOR_WIDTH + PADDING && mx < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollOptions(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollOptions(Mouse.getDWheel() / -0.05f);
             }
             onScrollOptions();
-        } else if (doPagesListScroll && xm >= 0 && xm <= pagesListWidth) {
+        } else if (doPagesListScroll && mx >= 0 && mx <= pagesListWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
@@ -244,8 +244,8 @@ public class ScreenOptions
         overlayBackground(0, width, bottom, height);
 
         Scissor.enable(0, top, width, bottom - top);
-        if (ym >= top && ym <= bottom) {
-            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, xm, ym);
+        if (my >= top && my <= bottom) {
+            drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, mx, my);
         } else {
             drawPageItems(pagesListWidth + SEPARATOR_WIDTH + PADDING, top - (int) optionsScrollAmount, pageWidth - 8, -1, -1);
         }
@@ -257,8 +257,8 @@ public class ScreenOptions
         if (pagesListHeight < bottom - top) {
             pagesListY = top + (bottom - top - pagesListHeight) / 2;
         }
-        if (ym >= top && ym <= bottom) {
-            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, xm, ym);
+        if (my >= top && my <= bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, mx, my);
         } else {
             drawPagesListItems(PADDING - 4, pagesListY, pagesListWidth - PADDING, -1, -1);
         }
@@ -305,10 +305,10 @@ public class ScreenOptions
         String titleLanguageKey = "gui.options.title";
         drawStringCentered(font, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
 
-        drawOptionsScrollBar(xm, ym);
-        drawPagesListScrollBar(xm, ym);
+        drawOptionsScrollBar(mx, my);
+        drawPagesListScrollBar(mx, my);
 
-        super.render(xm, ym, renderPartialTicks);
+        super.render(mx, my, renderPartialTicks);
 
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             drawRect(0, 0, width, height, 0xA0000000);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index e3badc430..1c6e6ff62 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -172,16 +172,16 @@ public class ScreenPaged
     }
 
     @Override
-    public void render(int xm, int ym, float renderPartialTicks)
+    public void render(int mx, int my, float renderPartialTicks)
     {
-        if (xm > leftWidth + SEPARATOR_WIDTH + PADDING && xm < width) {
+        if (mx > leftWidth + SEPARATOR_WIDTH + PADDING && mx < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollRightPanel(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollRightPanel(Mouse.getDWheel() / -0.05f);
             }
             onScrollRightPanel();
-        } else if (xm >= 0 && xm <= leftWidth) {
+        } else if (mx >= 0 && mx <= leftWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollLeftPanel(Mouse.getDWheel() / -0.01f);
             } else {
@@ -199,8 +199,8 @@ public class ScreenPaged
         overlayBackground(0, width, bottom, height);
 
         Scissor.enable(0, top, width, bottom - top);
-        if (ym >= top && ym <= bottom) {
-            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, xm, ym);
+        if (my >= top && my <= bottom) {
+            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, mx, my);
         } else {
             drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, -1, -1);
         }
@@ -212,8 +212,8 @@ public class ScreenPaged
         if (pagesListHeight < bottom - top) {
             pagesListY = top + (bottom - top - pagesListHeight) / 2;
         }
-        if (ym >= top && ym <= bottom) {
-            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, xm, ym);
+        if (my >= top && my <= bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, mx, my);
         } else {
             drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, -1, -1);
         }
@@ -259,10 +259,10 @@ public class ScreenPaged
 
         drawStringCentered(font, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
 
-        drawRightPanelScrollBar(xm, ym);
-        drawLeftPanelScrollBar(xm, ym);
+        drawRightPanelScrollBar(mx, my);
+        drawLeftPanelScrollBar(mx, my);
 
-        super.render(xm, ym, renderPartialTicks);
+        super.render(mx, my, renderPartialTicks);
     }
 
     protected void drawRightPanelScrollBar(int mouseX, int mouseY) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index f569d36b0..b7554f350 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -159,7 +159,7 @@ public final class PopupScreen
     }
 
     @Override
-    public void render(int xm, int ym, float partialTick)
+    public void render(int mx, int my, float partialTick)
     {
         int popupX = width / 2 - popupWidth / 2;
         int popupY = height / 2 - popupHeight / 2;
@@ -172,11 +172,11 @@ public final class PopupScreen
 
         for (PopupComponent component : components)
         {
-            component.render(popupX + HORIZONTAL_MARGIN, accY, xm, ym);
+            component.render(popupX + HORIZONTAL_MARGIN, accY, mx, my);
             accY += component.getHeight() + COMPONENT_GAP;
         }
 
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 
     private void drawPopupBackground()
diff --git a/game/client/src/main/java/net/minecraft/client/input/Gamepad.java b/game/client/src/main/java/net/minecraft/client/input/Gamepad.java
new file mode 100644
index 000000000..fb7f8c7c4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/input/Gamepad.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.input;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface Gamepad {
+
+    @NotNull String getGuid();
+
+    @NotNull String getName();
+
+    int getVendorId();
+
+    int getDeviceId();
+
+    void poll();
+
+    boolean hasAnyInput();
+
+    boolean isPresent();
+
+    float getAxisValue(final int axis);
+
+    boolean isButtonPressed(final int button);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
index bc3ce90e0..603ca3d92 100644
--- a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -2,15 +2,12 @@ package net.minecraft.client.input;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.input.glfw.GlfwGamepad;
-import net.minecraft.client.input.glfw.GlfwJoystick;
 import org.lwjgl.glfw.GLFW;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 import org.slf4j.Logger;
 
-import java.io.IOException;
-
 public abstract class InputHandler {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	private static Minecraft minecraft;
@@ -45,13 +42,11 @@ public abstract class InputHandler {
 					}
 				}
 			} else {
-				if (GLFW.glfwJoystickPresent(i)) {
-					GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
-					if (gamepad != null) {
-						ControllerInput input = new ControllerInput(minecraft, gamepad);
-						controllers[i] = input;
-						connected(input);
-					}
+				if (GLFW.glfwJoystickPresent(i) && GLFW.glfwJoystickIsGamepad(i)) {
+					GlfwGamepad gamepad = new GlfwGamepad(i);
+					ControllerInput input = new ControllerInput(minecraft, gamepad);
+					controllers[i] = input;
+					connected(input);
 				}
 			}
 		}
@@ -73,13 +68,11 @@ public abstract class InputHandler {
 	public static void initGLFW(Minecraft minecraft) throws Throwable {
 		int found = 0;
 		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
-			if (GLFW.glfwJoystickPresent(i)) {
-				GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
-				if (gamepad != null) {
-					ControllerInput input = new ControllerInput(minecraft, gamepad);
-					controllers[i] = input;
-					found++;
-				}
+			if (GLFW.glfwJoystickPresent(i) && GLFW.glfwJoystickIsGamepad(i)) {
+				GlfwGamepad gamepad = new GlfwGamepad(i);
+				ControllerInput input = new ControllerInput(minecraft, gamepad);
+				controllers[i] = input;
+				found++;
 			}
 		}
 //		int[] vids = { 0x0079, 0x0079, 0x054c, 0x0079, 0x03F0, 0x057e, 0x28de, 0x28de };
diff --git a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
index 0d2bbe04a..322792f2b 100644
--- a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -39,7 +39,7 @@ public class PlayerInput {
 		}
 		
 		if(gameSettings.keySneak.isKeyboardKey(keyCode)) {
-			if(gameSettings.sneakToggle.value) {
+			if(gameSettings.sneakToggle.value && !mc.thePlayer.noPhysics) {
 				if(pressed) {
 					sneak = !sneak;
 				}
@@ -95,8 +95,12 @@ public class PlayerInput {
 			moveForward = -mc.controllerInput.joyLeft.getY();
 			moveStrafe = -mc.controllerInput.joyLeft.getX();
 			jump = mc.controllerInput.buttonA.isPressed();
-			if(mc.controllerInput.joyRight.getButton().pressedThisFrame()) {
-				sneak = !sneak;
+			if (mc.thePlayer.noPhysics) {
+				sneak = mc.controllerInput.joyRight.getButton().isPressed();
+			} else {
+				if(mc.controllerInput.joyRight.getButton().pressedThisFrame()) {
+					sneak = !sneak;
+				}
 			}
 		}
 
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java b/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
index 8e257c057..d34d9bbfe 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/Joystick.java
@@ -40,18 +40,21 @@ public class Joystick{
 		
 		float x = this.joystickListener.getValue(xAxis);
 		float y = this.joystickListener.getValue(yAxis);
+
+		float length = (float) Math.sqrt(x * x + y * y);
 		
-		boolean xInDeadzone = x < deadzone.value && x > -deadzone.value;
-		boolean yInDeadzone = y < deadzone.value && y > -deadzone.value;
-		
-		if(xInDeadzone) x = 0.0f;
-		if(yInDeadzone) y = 0.0f;
-		
+		boolean inDeadzone = length < deadzone.value;
+
+		if (inDeadzone) {
+			x = 0.0f;
+			y = 0.0f;
+		}
+
 		this.x = x;
 		this.y = y;
 		
 		moveLastFrame = moving;
-		moving = !(xInDeadzone && yInDeadzone);
+		moving = !inDeadzone;
 	}
 	
 	public boolean stoppedMoving() {
diff --git a/game/client/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java b/game/client/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java
index a76eaa804..d0dbe9f0f 100644
--- a/game/client/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java
+++ b/game/client/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.input.glfw;
 
+import org.jetbrains.annotations.NotNull;
+
 public class FakeGamepad extends GlfwGamepad {
     private final String name;
     private final int vid;
@@ -14,7 +16,7 @@ public class FakeGamepad extends GlfwGamepad {
     }
 
     @Override
-    public String getGuid() {
+    public @NotNull String getGuid() {
         return "00000000000000000000000000000000";
     }
 
@@ -39,7 +41,7 @@ public class FakeGamepad extends GlfwGamepad {
     }
 
     @Override
-    public String getName() {
+    public @NotNull String getName() {
         return name;
     }
 
@@ -52,14 +54,4 @@ public class FakeGamepad extends GlfwGamepad {
     public boolean isButtonPressed(int button) {
         return false;
     }
-
-    @Override
-    public int getHatValue(int hat) {
-        return 0;
-    }
-
-    @Override
-    public GlfwGamepad intoGamepad() {
-        return this;
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java b/game/client/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java
index 5cc120b09..6c49c2dff 100644
--- a/game/client/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java
+++ b/game/client/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java
@@ -1,20 +1,70 @@
 package net.minecraft.client.input.glfw;
 
+import net.minecraft.client.input.Gamepad;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.glfw.GLFW;
 import org.lwjgl.glfw.GLFWGamepadState;
 
 import java.nio.ByteBuffer;
+import java.nio.FloatBuffer;
 
-public class GlfwGamepad extends GlfwJoystick {
+public class GlfwGamepad implements Gamepad {
+    private final int id;
+    private final int vid;
+    private final int did;
     private GLFWGamepadState state = null;
 
     public GlfwGamepad(int id) {
-        super(id);
+        this.id = id;
+
+        String guid = this.getGuid();
+
+        int vid;
+        try {
+            String lower = guid.substring(8, 10);
+            String upper = guid.substring(10, 12);
+            vid = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + id + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        int did;
+        try {
+            String lower = guid.substring(16, 18);
+            String upper = guid.substring(18, 20);
+            did = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + id + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        this.vid = vid;
+        this.did = did;
+    }
+
+    public int getId() {
+        return this.id;
+    }
+
+    public @NotNull String getGuid() {
+        return GLFW.glfwGetJoystickGUID(this.id);
+    }
+
+    public int getVendorId() {
+        return this.vid;
+    }
+
+    public int getDeviceId() {
+        return this.did;
     }
 
     @Override
     public void poll() {
-        super.poll();
         this.state = new GLFWGamepadState(ByteBuffer.allocateDirect(GLFWGamepadState.SIZEOF));
         GLFW.glfwGetGamepadState(this.getId(), this.state);
     }
@@ -36,7 +86,12 @@ public class GlfwGamepad extends GlfwJoystick {
     }
 
     @Override
-    public String getName() {
+    public boolean isPresent() {
+        return GLFW.glfwJoystickPresent(this.id);
+    }
+
+    @Override
+    public @NotNull String getName() {
         if (this.getVendorId() == 0x7475) {
             return GLFW.glfwGetJoystickName(this.getId()) + " " + this.getId();
         }
@@ -60,9 +115,4 @@ public class GlfwGamepad extends GlfwJoystick {
 
         return false;
     }
-
-    @Override
-    public GlfwGamepad intoGamepad() {
-        return this;
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index bf0635aa5..49e431012 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -196,7 +196,7 @@ public class PacketHandlerClient extends PacketHandler
         } else {
             owner = null;
         }
-        Entity newEntity = NetEntityHandler.getTypeEntry(addEntityPacket.type).getEntity(worldClientMP, xPosition, yPosition, zPosition, addEntityPacket.metaData, addEntityPacket.hasVelocity, addEntityPacket.xVelocity / 8000D, addEntityPacket.yVelocity / 8000D, addEntityPacket.zVelocity / 8000D, owner);
+        Entity newEntity = NetEntityHandler.getTypeEntry(addEntityPacket.type).getEntity(worldClientMP, xPosition, yPosition, zPosition, addEntityPacket.metaData, addEntityPacket.hasVelocity, addEntityPacket.xVelocity / 8000D, addEntityPacket.yVelocity / 8000D, addEntityPacket.zVelocity / 8000D, owner, addEntityPacket.tag);
         if (newEntity != null) {
             newEntity.serverPosX = addEntityPacket.xPosition;
             newEntity.serverPosY = addEntityPacket.yPosition;
diff --git a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index f914ade77..9d14230d7 100644
--- a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -19,8 +19,11 @@ public class ThreadPingServer
     public ThreadPingServer(ScreenSelectServer screen, ServerData server) {
         this.screen = screen;
         this.server = server;
-        ServerAddress address = server.getServerAddress();
-        this.setName("ThreadPingServer - " + address.getIP() + ":" + address.getPort());
+//        Turns out getting the real address like this is horribly horribly slow, taking me sometime 40 seconds to process all of these set names
+//        ServerAddress address = server.getServerAddress();
+//        this.setName("ThreadPingServer - " + address.getIP() + ":" + address.getPort());
+
+        this.setName("ThreadPingServer - " + server.address);
     }
 
     public ServerData getServer() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index c155b498d..6a6fa7905 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -37,7 +37,7 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     @Override
     public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         boolean invTint = renderBlocks.useInventoryTint;
-        renderBlocks.useInventoryTint = (canBeRetro && isRetro());
+        renderBlocks.useInventoryTint = !canBeRetro || !isRetro();
         super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         renderBlocks.useInventoryTint = invTint;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index d338c927d..dc3aaf49f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -102,17 +102,19 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
             TileEntity tileEntity = world.getBlockEntity(xo, yo, zo);
             world.removeBlockTileEntity(xo, yo, zo);
             world.setBlockWithNotify(xo, yo, zo, 0);
-            EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id(), blockMeta, tileEntity);
-            entityFallingBlock.hasRemovedBlock = true;
-            if (tileEntity instanceof IVehicle) {
-                Entity rider = ((IVehicle) tileEntity).getPassenger();
-                ((IVehicle) tileEntity).ejectRider();
-                if (rider != null) rider.startRiding(entityFallingBlock);
+            if (!world.isClientSide) {
+                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id(), blockMeta, tileEntity);
+                entityFallingBlock.hasRemovedBlock = true;
+                if (tileEntity instanceof IVehicle) {
+                    Entity rider = ((IVehicle) tileEntity).getPassenger();
+                    ((IVehicle) tileEntity).ejectRider();
+                    if (rider != null) rider.startRiding(entityFallingBlock);
+                }
+                world.entityJoinedWorld(entityFallingBlock);
+                final double speed = 2;
+                entityFallingBlock.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
+                flungBlock = entityFallingBlock;
             }
-            world.entityJoinedWorld(entityFallingBlock);
-            final double speed = 2;
-            entityFallingBlock.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
-            flungBlock = entityFallingBlock;
         }
         return true;
     }
@@ -130,6 +132,66 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
         return true;
     }
 
+    @Override
+    protected boolean tryExtend(World world, int x, int y, int z, Direction direction, int maxPushedBlocks) {
+        if (world.isClientSide) { // "Fixes" steel pistons appearing to push the block they just flung
+            int data = world.getBlockMetadata(x, y, z);
+            int xo = x + direction.getOffsetX();
+            int yo = y + direction.getOffsetY();
+            int zo = z + direction.getOffsetZ();
+            int blocks = 0;
+            while (true) {
+                if (blocks >= maxPushedBlocks + 1) {
+                    break;
+                }
+                if (yo < 0 || yo >= world.getHeightBlocks()) {
+                    return false;
+                }
+                int blockId = world.getBlockId(xo, yo, zo);
+                if (blockId == 0) {
+                    break;
+                }
+                if (!isPushable(blockId, world, xo, yo, zo, true)) {
+                    return false;
+                }
+                if (Blocks.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+                    Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
+                    break;
+                }
+                if (blocks == maxPushedBlocks) {
+                    return false;
+                }
+                xo += direction.getOffsetX();
+                yo += direction.getOffsetY();
+                zo += direction.getOffsetZ();
+                blocks++;
+            }
+            if (blocks == 1) {
+                while (xo != x || yo != y || zo != z) {
+                    int px = xo - direction.getOffsetX();
+                    int py = yo - direction.getOffsetY();
+                    int pz = zo - direction.getOffsetZ();
+                    int pushId = world.getBlockId(px, py, pz);
+                    TileEntity pushEntity = world.getBlockEntity(px, py, pz);
+                    if (pushEntity instanceof TileEntityMovingPistonBlock && px == x && py == y && pz == z) {
+                        break;
+                    }
+                    if(pushId == block.id() && px == x && py == y && pz == z)
+                    {
+                        createPistonHeadAt(world, xo, yo, zo, data, direction);
+                    }
+                    if (!(px == x && py == y && pz == z))
+                        world.setBlockAndMetadataRaw(px, py, pz, 0, 0);
+                    xo = px;
+                    yo = py;
+                    zo = pz;
+                }
+                return true;
+            }
+        }
+        return super.tryExtend(world, x, y, z, direction, maxPushedBlocks);
+    }
+
     @Override
     public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
         List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
